open Llvm

open KaleidoscopeAST
open KaleidoscopeLexer
open KaleidoscopeParser

let main () =
	let lexbuf = Lexing.from_channel stdin in
		while true do
			print_string "\nready> ";
			flush stdout;
		
			try
				(* This is all very ugly, but due to the nature of the *)
				(* steps that need to be taken in each case in         *)
				(* reguards to the JIT compilation there is really no  *)
				(* other place to put it all.                          *)
				let node = (KaleidoscopeParser.input KaleidoscopeLexer.token lexbuf) in
					match node with
						  Expression(e) ->
						  	print_endline "Parsed an expression.";
						| Func(f) ->
							print_endline "Parsed a function definition.";
						| Proto(p) ->
							print_endline "Parsed a prototype or extern definition.";
	          with
	                 End_of_file ->
					print_string "\n";
					exit 0
	               | KaleidoscopeLexer.Error s ->
	                    print_endline s;
	               | Parsing.Parse_error ->
	                    print_endline "We encountered a parsing error.";
	     done

let _ = main ()
