open Llvm

open KaleidoscopeAST
open KaleidoscopeLexer
open KaleidoscopeParser
open KaleidoscopeTranslator
open KaleidoscopeJIT

let main () =
(*	KaleidoscopeJIT.setup_optimizations ()	;*)
	let lexbuf = Lexing.from_channel stdin in
		while true do
			print_string "\nready> ";
			flush stdout;
		
			try
				(* This is all very ugly, but due to the nature of the *)
				(* steps that need to be taken in each case in         *)
				(* reguards to the JIT compilation there is really no  *)
				(* other place to put it all.                          *)
				let node = (KaleidoscopeParser.input KaleidoscopeLexer.token lexbuf) in
					match node with
						  Expression(e) ->
						  	let ir = translate_function (Function(Prototype("", []), e)) in
						  		let oir = KaleidoscopeJIT.optimize ir in
						  			dump_value oir;
						  			print_string "\n=> ";
						  			print_float (KaleidoscopeJIT.execute oir);
						| Func(f) ->
							let ir = translate_function f in
								let oir = KaleidoscopeJIT.optimize ir in
									dump_value oir;
						| Proto(p) ->
							let ir = translate_prototype p in
								dump_value ir;
	          with
	                 End_of_file ->
					print_endline "\nYou have exited the interpreter.  Here is the resulting module from your session.";
					dump_module KaleidoscopeTranslator.working_module;
					print_string "\n";
					exit 0
	               | KaleidoscopeLexer.Error s
	               | KaleidoscopeTranslator.Error s ->
	                    print_endline s;
	               | Parsing.Parse_error ->
	                    print_endline "We encountered a parsing error.";
	     done

let _ = main ()
